//-----------------------------------------------------------------------------
// File: kyuu.cs
//
// Starting point for new Direct3D applications
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------


//#define DEBUG_VS   // Uncomment this line to debug vertex shaders 
//#define DEBUG_PS   // Uncomment this line to debug pixel shaders 

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

namespace kyuu
{
    /// <summary>kyuu Sample Class</summary>
    public class kyuu : IFrameworkCallback, IDeviceCreation
    {
        #region Creation
        /// <summary>Create a new instance of the class</summary>
        public kyuu(Framework f) 
        { 
            // Store framework
            sampleFramework = f; 
            // Create dialogs
            hud = new Dialog(sampleFramework); 
            sampleUi = new Dialog(sampleFramework); 
        }
        #endregion

        // Variables
        private Framework sampleFramework = null; // Framework for samples
        private Font statsFont = null; // Font for drawing text
        private Sprite textSprite = null; // Sprite for batching text calls
        private Effect effect = null; // D3DX Effect Interface
        private ModelViewerCamera camera = new ModelViewerCamera(); // A model viewing camera

        private bool isHelpShowing = true; // If true, renders the UI help text

        private Dialog hud = null; // dialog for standard controls
        private Dialog sampleUi = null; // dialog for sample specific controls

        // HUD Ui Control constants
        private const int ToggleFullscreen = 1;
        private const int ToggleReference = 3;
        private const int ChangeDevice = 4;

        // --------------------------------
        // fps
        private float m_f`掞 = 0.0f;

        // --------------------------------
        // eTCY        
        float O = 384400f; // ̎_p

        float na = 6378.15f;
        float ja = 1220f;
        float Oja = 3480f;

        float a = 1737.4f;

        float OXe[Va = 16f;   // ̍\
        float _a = 0.001f;            // _̒SƂȂ鋅

        float Î~O = 42200f; // n̒S̋
        float OXgO = 142000f; // n̒S̋

        float OGx[^a1 = 2f;     // OXe[Vł̔a
        float OGx[^a2 = 0.01f; // n\Ɩ[ł̔a

        float cameraDefn = 21000f;   // ftHgJ(nS)
        float cameraDef\ = 0.01f;    // ftHgJ(n\/Oj\/j\/\)
        float cameraDefw = 128f;     // ftHgJ(OXe[V)

        float cameraMin = 0.005f;   // ŏJ
        float cameraMax = 1200000f; // őJ

        float \ʕ\_ = 0.1f;    // n\/Oj\/j\/\ Ɏ_痣
                                        // 0ƌ덷ɂ\ԂB

        float cameraNear = 0.001f;      // `ŏ
        float cameraFar = 1600000.0f;   // `ő勗
        float OGx[^㉺ = 100f;        // J[\L[ɂ㉺;





/*
        // 100kmP
        float O = 3844.00f; // ̎_p

        float na = 63.7815f;
        float ja = 12.20f;
        float Oja = 34.80f;

        float a = 17.374f;

        float OXe[Va = 0.16f;   // ̍\
        float _a = 0.00001f;            // _̒SƂȂ鋅

        float Î~O = 422.00f;               // n̒S̋
        float OXgO = 1420.00f;        // n̒S̋

        float OGx[^a1 = 0.02f;      // OXe[Vł̔a
        float OGx[^a2 = 0.0001f;    // n\Ɩ[ł̔a

        float cameraDefn = 210.00f;  // ftHgJ(nS)
        float cameraDef\ = 0.0001f;  // ftHgJ(n\/Oj\/j\/\)
        float cameraDefw = 1.28f;      // ftHgJ(OXe[V)

        float cameraMin = 0.00005f;     // ŏJ
        float cameraMax = 12000.00f;    // őJ

        float cameraNear = 0.00001f;    // ŏ`͈
        float cameraFar = 10000.0f;     // ő`͈


        float   \ʕ\_ = 0.0005f;   // n\/Oj\/j\/\ Ɏ_痣
                                            // 0ƌ덷ɂ\ԂB

        float OGx[^㉺ = 1f;        // J[\L[ɂ㉺;
*/

        /*
        a
            n	 6378.15 km 
            j	 1220    km
            Oj	 3480    km
            		 1737.4  km 
        n̒SÎ~O܂ł̋42200km
        */

        float cameraAspectRatio = 0f;   // camera p[^

        // --------------------------------
        // 

        // W\
        private  an = null;
        private  bj = null;
        private  cOj = null;
        private  d   = null;

        // _߂ꍇ̍ו\
        private  ans = null;
        private  bjs = null;
        private  cOjs = null;
        private  ds   = null;

        private  eOXe[V = null;

        private  f_ = null;  // _̒S

        private ~ ~a = null;
        private ~ ~b = null;

        private  a = null;
        private  b = null;


        // -----
        // _ʒu̎
        private _ _ʒu = _.nS;

        private enum _
        {
            nS,

            n\,
            Oj\,
            j\,

            \,

            OXe[V,
            n\Xe[V
        };


        // --------------------------------
        // _SW
        private Vector3 defaultDir = Vector3.Empty;
        private Vector3 currentDir = Vector3.Empty;

        private Matrix rotation  = Matrix.Identity;  // _]p
        private Matrix rotationX = Matrix.Identity;  // _]p
        private Matrix rotationY = Matrix.Identity;  // _]p

        private float angX = 0f; // _̒SƂȂẄʒu]px
        private float angY = 0f;

        private float ݍx   = 0f;    // OGx[^ݍx n̒S:0

        private Vector3 vp = Vector3.Empty;  // _SW

        // ʂɕ\px
        float pxx = 0f;
        float pxy = 0f;


        // OGx[^mesh\Ƌɂ茩ȂB
        // \邱Ƃɂ苗Ɋ֌WȂ
        private bool b\ = true;        // OGx[^\

        private bool b\bh\ = false; // Ṽ\bh\ؑ


        /// <summary>
        /// Called during device initialization, this code checks the device for some 
        /// minimum set of capabilities, and rejects those that don't pass by returning false.
        /// </summary>
        public bool IsDeviceAcceptable(Caps caps, Format adapterFormat, Format backBufferFormat, bool windowed)
        {
            // Skip back buffer formats that don't support alpha blending
            if (!Manager.CheckDeviceFormat(caps.AdapterOrdinal, caps.DeviceType, adapterFormat, 
                Usage.QueryPostPixelShaderBlending, ResourceType.Textures, backBufferFormat))
                return false;

            return true;
        }

        /// <summary>
        /// This callback function is called immediately before a device is created to allow the 
        /// application to modify the device settings. The supplied settings parameter 
        /// contains the settings that the framework has selected for the new device, and the 
        /// application can make any desired changes directly to this structure.  Note however that 
        /// the sample framework will not correct invalid device settings so care must be taken 
        /// to return valid device settings, otherwise creating the Device will fail.  
        /// </summary>
        public void ModifyDeviceSettings(DeviceSettings settings, Caps caps)
        {
            // If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
            // then switch to SWVP.
            if ( (!caps.DeviceCaps.SupportsHardwareTransformAndLight) ||
                (caps.VertexShaderVersion < new Version(1,1)) )
            {
                settings.BehaviorFlags = CreateFlags.SoftwareVertexProcessing;
            }
            else
            {
                settings.BehaviorFlags = CreateFlags.HardwareVertexProcessing;
            }

            // This application is designed to work on a pure device by not using 
            // any get methods, so create a pure device if supported and using HWVP.
            if ( (caps.DeviceCaps.SupportsPureDevice) && 
                ((settings.BehaviorFlags & CreateFlags.HardwareVertexProcessing) != 0 ) )
                settings.BehaviorFlags |= CreateFlags.PureDevice;

            // Debugging vertex shaders requires either REF or software vertex processing 
            // and debugging pixel shaders requires REF.  
#if(DEBUG_VS)
            if (settings.DeviceType != DeviceType.Reference )
            {
                settings.BehaviorFlags &= ~CreateFlags.HardwareVertexProcessing;
                settings.BehaviorFlags |= CreateFlags.SoftwareVertexProcessing;
            }
#endif
#if(DEBUG_PS)
            settings.DeviceType = DeviceType.Reference;
#endif
            // For the first device created if its a REF device, optionally display a warning dialog box
            if (settings.DeviceType == DeviceType.Reference)
            {
                Utility.DisplaySwitchingToRefWarning(sampleFramework, "kyuu");
            }

        }

        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// created, which will happen during application initialization and windowed/full screen 
        /// toggles. This is the best location to create Pool.Managed resources since these 
        /// resources need to be reloaded whenever the device is destroyed. Resources created  
        /// here should be released in the Disposing event. 
        /// </summary>
        private void OnCreateDevice(object sender, DeviceEventArgs e)
        {
            // Initialize the stats font
            statsFont = ResourceCache.GetGlobalInstance().CreateFont(e.Device, 15, 0, FontWeight.Bold, 1, false, CharacterSet.Default,
                Precision.Default, FontQuality.Default, PitchAndFamily.FamilyDoNotCare | PitchAndFamily.DefaultPitch
                , "Arial");

            // Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the 
            // shader debugger. Debugging vertex shaders requires either REF or software vertex 
            // processing, and debugging pixel shaders requires REF.  The 
            // ShaderFlags.Force*SoftwareNoOptimizations flag improves the debug experience in the 
            // shader debugger.  It enables source level debugging, prevents instruction 
            // reordering, prevents dead code elimination, and forces the compiler to compile 
            // against the next higher available software target, which ensures that the 
            // unoptimized shaders do not exceed the shader model limitations.  Setting these 
            // flags will cause slower rendering since the shaders will be unoptimized and 
            // forced into software.  See the DirectX documentation for more information about 
            // using the shader debugger.
            ShaderFlags shaderFlags = ShaderFlags.NotCloneable;
#if(DEBUG_VS)
            shaderFlags |= ShaderFlags.ForceVertexShaderSoftwareNoOptimizations;
#endif
#if(DEBUG_PS)
            shaderFlags |= ShaderFlags.ForcePixelShaderSoftwareNoOptimizations;
#endif
            // Read the D3DX effect file
            string path = Utility.FindMediaFile("kyuu.fx");
            effect = ResourceCache.GetGlobalInstance().CreateEffectFromFile(e.Device,
                path, null, null, shaderFlags, null);

            // Setup the camera's view parameters
            camera.SetViewParameters(new Vector3(0.0f, 0.0f, -5.0f), Vector3.Empty);

            // ppp
            camera.SetRadius(cameraDefn, cameraMin, cameraMax);   // J̋ default,min,max

            camera.SetModelCenter(Vector3.Empty);	// w̍W`̒SƂ

        }

        

        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// reset, which will happen after a lost device scenario. This is the best location to 
        /// create Pool.Default resources since these resources need to be reloaded whenever 
        /// the device is lost. Resources created here should be released in the OnLostDevice 
        /// event. 
        /// </summary>
        private void OnResetDevice(object sender, DeviceEventArgs e)
        {
            SurfaceDescription desc = e.BackBufferDescription;

            // Create a sprite to help batch calls when drawing many lines of text
            textSprite = new Sprite(e.Device);

            // Setup the camera's projection parameters
            float aspectRatio = (float)desc.Width / (float)desc.Height;

            // JɂSetProjectionParameterss邽߃oϐɕۑB
            cameraAspectRatio = aspectRatio;   // camera p[^

            // ppp ͈͂wB
            // ! ͈͂傫ƉAʏȂB(near ̏_ȉ̐l)
            // ccc
//          camera.SetProjectionParameters( (float)Math.PI / 4, cameraAspectRatio, cameraNear, cameraFar );


            // _ʂɂAcamera.SetProjectionParametersؑ
            switch (_ʒu)
            {
                case _.nS:
                    camera.SetProjectionParameters((float)Math.PI / 4, cameraAspectRatio, 100f, cameraFar);
                    break;

                case _.n\:
                case _.Oj\:
                case _.j\:
                case _.\:
                    camera.SetProjectionParameters((float)Math.PI / 4, cameraAspectRatio, cameraNear, cameraFar);
                    break;

                case _.OXe[V:
                case _.n\Xe[V:
                    camera.SetProjectionParameters((float)Math.PI / 4, cameraAspectRatio, 1f, cameraFar);
                    break;

            }

            camera.SetWindow(desc.Width, desc.Height);

            // camera.SetProjectionParameters camera.SetWindow͑gݍ킹Ďg?

            // ppp
            // Set device transforms
            e.Device.Transform.Projection = camera.ProjectionMatrix;

            // Cgݒ
            // .xt@C烍[hꂽbV̕\Ɏgp
            // [0]:Cgԍ0ɐݒ
            // Ft̕sݒ
            e.Device.Lights[0].Type = LightType.Directional;
            e.Device.Lights[0].Diffuse = System.Drawing.Color.White;
            e.Device.Lights[0].Direction = new Vector3(-1.0f, 0.0f, 0.0f);
            e.Device.Lights[0].Enabled = true; // Cg I

            // JOItɂāA[U[ɎOp`̑OʂƔwʂ悤ɂ܂B
            e.Device.RenderState.CullMode = Cull.None;
//          e.Device.RenderState.CullMode = Cull.CounterClockwise;  // ftHg


            e.Device.RenderState.Lighting = true;
//          e.Device.RenderState.Lighting = false;

//          e.Device.RenderState.FillMode = FillMode.Solid;
            e.Device.RenderState.FillMode = FillMode.WireFrame;

            // Z obt@Iɂ܂B
            e.Device.RenderState.ZBufferEnable = true;


            // ArGg I
            // ArGǵAgUAׂẴIuWFNglɏƂ炷CgB
            e.Device.RenderState.Ambient = System.Drawing.Color.FromArgb(0xa0a0a0);
//          e.Device.RenderState.Ambient = System.Drawing.Color.White;

            this.an.CreateVB(e.Device, System.Drawing.Color.SkyBlue,   na, 32, 16);    // n
            this.bj.CreateVB(e.Device, System.Drawing.Color.Red,       ja, 32, 16);    // j
            this.cOj.CreateVB(e.Device, System.Drawing.Color.Yellow,    Oja, 32, 16);    // Oj
            this.d.  CreateVB(e.Device, System.Drawing.Color.Gold,      a,   32, 16);    // 


            this.ans.CreateVB(e.Device, System.Drawing.Color.SkyBlue,  na, 128, 64);  // n
            this.bjs.CreateVB(e.Device, System.Drawing.Color.Red,      ja, 128, 64);  // j
            this.cOjs.CreateVB(e.Device, System.Drawing.Color.Yellow,   Oja, 128, 64);  // Oj
            this.ds.  CreateVB(e.Device, System.Drawing.Color.Gold,     a,   128, 64);    // 


            this.eOXe[V.CreateVB(e.Device, System.Drawing.Color.BlueViolet, OXe[Va, 32, 16);    // OXe[V

            this.f_.CreateVB(e.Device, System.Drawing.Color.White,     _a, 8, 4);    // _:a1m

            // http://www.sci.osaka-cu.ac.jp/~yoshino/Orbit/Orbit.htm 
            this.~a.CreateVB(e.Device, System.Drawing.Color.White, OGx[^a2, OGx[^a1, Î~O - na);          // OGx[^
            // n̒SÎ~O܂ł̋42200km
            // na:10m Î~Oa:2000m 

            this.~b.CreateVB(e.Device, System.Drawing.Color.Red, OGx[^a1, OGx[^a2, OXgO - Î~O);    // OXgO
            // dSÎ~OɂЂlHq n̒S̒142000f
            // Î~Oa:2000m n̔Αa:10m 


            // ɂOGx[^
            this.a.CreateVB(e.Device, System.Drawing.Color.Wheat, new Vector3(na, 0, 0), new Vector3(Î~O, 0, 0));          // OXgO
            this.b.CreateVB(e.Device, System.Drawing.Color.Red,   new Vector3(Î~O, 0, 0), new Vector3(OXgO, 0, 0));    // OXgO


            // Setup UI locations
            hud.SetLocation(desc.Width-170, 0);
            hud.SetSize(170,170);
            sampleUi.SetLocation(desc.Width - 170, desc.Height - 350);
            sampleUi.SetSize(170,300);
        }

        /// <summary>
        /// This event function will be called fired after the Direct3D device has 
        /// entered a lost state and before Device.Reset() is called. Resources created
        /// in the OnResetDevice callback should be released here, which generally includes all 
        /// Pool.Default resources. See the "Lost Devices" section of the documentation for 
        /// information about lost devices.
        /// </summary>
        private void OnLostDevice(object sender, EventArgs e)
        {
            if (textSprite != null)
            {
                textSprite.Dispose();
                textSprite = null;
            }

            if (this.an != null) this.an.Dispose();
            if (this.bj != null) this.bj.Dispose();
            if (this.cOj != null) this.cOj.Dispose();
            if (this.d   != null) this.d  .Dispose();

            if (this.ans != null) this.ans.Dispose();
            if (this.bjs != null) this.bjs.Dispose();
            if (this.cOjs != null) this.cOjs.Dispose();
            if (this.ds   != null) this.ds.  Dispose();



            if (this.eOXe[V != null) this.eOXe[V.Dispose();
            if (this.f_ != null) this.eOXe[V.Dispose();

            if (this.~a != null) this.~a.Dispose();
            if (this.~b != null) this.~b.Dispose();

            if (this.a != null) this.a.Dispose();
            if (this.b != null) this.b.Dispose();

        }

        /// <summary>
        /// This callback function will be called immediately after the Direct3D device has 
        /// been destroyed, which generally happens as a result of application termination or 
        /// windowed/full screen toggles. Resources created in the OnCreateDevice callback 
        /// should be released here, which generally includes all Pool.Managed resources. 
        /// </summary>
        private void OnDestroyDevice(object sender, EventArgs e)
        {
        }

        /// <summary>
        /// This callback function will be called once at the beginning of every frame. This is the
        /// best location for your application to handle updates to the scene, but is not 
        /// intended to contain actual rendering calls, which should instead be placed in the 
        /// OnFrameRender callback.  
        /// </summary>
        public void OnFrameMove(Device device, double appTime, float elapsedTime)
        {
            // Update the camera's position based on user input 
            camera.FrameMove(elapsedTime);


            // ppp
            // [hs r[sݒ
            // (HLSLgpȂ\̏ꍇɕKv)
            device.Transform.World = camera.WorldMatrix;
            device.Transform.View = camera.ViewMatrix;


            // -------------------------------------------------------------------------
            // fps 60fps
            // memo:tXN[fpsRefresh RateɈˑB
            float f = (float)FrameworkTimer.GetTime();
            if (f < m_f`掞)
            {
                System.Threading.Thread.Sleep((int)((m_f`掞 - f) * 1000)); // ~bP
            }
            m_f`掞 = (float)FrameworkTimer.GetTime() + 0.0167f;  // 16.7ms  1/60sec    // bP

        }

        
        
        
        /// <summary>
        /// This callback function will be called at the end of every frame to perform all the 
        /// rendering calls for the scene, and it will also be called if the window needs to be 
        /// repainted. After this function has returned, the sample framework will call 
        /// Device.Present to display the contents of the next buffer in the swap chain
        /// </summary>
        public void OnFrameRender(Device device, double appTime, float elapsedTime)
        {
            bool beginSceneCalled = false;

            // Clear the render target and the zbuffer 
//          device.Clear(ClearFlags.ZBuffer | ClearFlags.Target, 0x002D32AA, 1.0f, 0);
            device.Clear(ClearFlags.ZBuffer | ClearFlags.Target, 0x00000000, 1.0f, 0);

            try
            {
                device.BeginScene();
                beginSceneCalled = true;

                // Update the effect's variables.  Instead of using strings, it would 
                // be more efficient to cache a handle to the parameter by calling 
                // Effect.GetParameter
                effect.SetValue("worldViewProjection", camera.WorldMatrix * camera.ViewMatrix * camera.ProjectionMatrix);
                effect.SetValue("worldMatrix", camera.WorldMatrix);
                effect.SetValue("appTime", (float)appTime);


                if (b\bh\)
                {
                    device.RenderState.CullMode = Cull.CounterClockwise;  // JO on
                    device.RenderState.FillMode = FillMode.Solid;   // \bh\
                }
                else
                {
                    device.RenderState.CullMode = Cull.None;    // JO off
                    device.RenderState.FillMode = FillMode.WireFrame;   // C[t[\
                }


                switch (_ʒu)
                {
                    case _.n\:
                        {
                            this.ans.Draw(device, camera, Vector3.Empty - vp);
                            this.bj.Draw(device, camera, Vector3.Empty - vp);
                            this.cOj.Draw(device, camera, Vector3.Empty - vp);
                            this.d.Draw(device, camera, new Vector3(O, 0, 0) - vp);   // Oϔa 384,400 km 
                        }
                        break;

                    case _.Oj\:
                        {
                            this.an.Draw(device, camera, Vector3.Empty - vp);
                            this.bj.Draw(device, camera, Vector3.Empty - vp);
                            this.cOjs.Draw(device, camera, Vector3.Empty - vp);
                            this.d.Draw(device, camera, new Vector3(O, 0, 0) - vp);   // Oϔa 384,400 km 
                        }
                        break;
                    case _.j\:
                        {
                            this.an.Draw(device, camera, Vector3.Empty - vp);
                            this.bjs.Draw(device, camera, Vector3.Empty - vp);
                            this.cOj.Draw(device, camera, Vector3.Empty - vp);
                            this.d.Draw(device, camera, new Vector3(O, 0, 0) - vp);   // Oϔa 384,400 km 
                        }
                        break;

                    case _.\:
                        {
                            this.an.Draw(device, camera, Vector3.Empty - vp);
                            this.bj.Draw(device, camera, Vector3.Empty - vp);
                            this.cOj.Draw(device, camera, Vector3.Empty - vp);
                            this.ds.Draw(device, camera, new Vector3(O, 0, 0) - vp);   // Oϔa 384,400 km 
                        }
                        break;


                    default:
                        {
                            this.an.Draw(device, camera, Vector3.Empty - vp);
                            this.bj.Draw(device, camera, Vector3.Empty - vp);
                            this.cOj.Draw(device, camera, Vector3.Empty - vp);
                            this.d.Draw(device, camera, new Vector3(O, 0, 0) - vp);   // Oϔa 384,400 km 
                        }
                        break;
                }



                this.f_.Draw(device, camera, new Vector3(0, 0, 0));   // _̒S

                // ------------------------------------------------------------------------
                // OGx[^[

                // Î~OXe[V
                this.eOXe[V.Draw(device, camera, new Vector3( Î~O, 0, 0) - vp);  // OXe[V
                this.eOXe[V.Draw(device, camera, new Vector3( na, 0, 0) - vp);  // n\Xe[V

                if (b\)
                {
                    // ɂ\
                    this.a.Draw(device, camera, Vector3.Empty - vp); // n\ - Î~O
                    this.b.Draw(device, camera, Vector3.Empty - vp); // Î~O - n̔Ε
                }


device.RenderState.CullMode = Cull.CounterClockwise;  // ftHg
device.RenderState.FillMode = FillMode.Solid;



                // |Sɂ\
                // n\ʂÎ~O܂
                this.~a.Draw(device, camera, new Vector3(na + ((Î~O - na) / 2), 0, 0) - vp);  // n̒SÎ~O܂ł̋42200km

                // OXgO Î~On̔΂
                this.~b.Draw(device, camera, new Vector3(Î~O + ((OXgO - Î~O) / 2), 0, 0) - vp); // OXgO 142000f

                // 142000f:n̒SOXgOI[܂ł̒
                //  42200f:n̒SÎ~O܂ł̋
                // 142000f-42200f:Î~On̔Ε֐Lт钷



                // ------------------------------------------------------------------------

                // Show frame rate
                RenderText();

                // Show UI
                hud.OnRender(elapsedTime);
                sampleUi.OnRender(elapsedTime);
            }
            finally
            {
                if (beginSceneCalled)
                    device.EndScene();
            }
        }






        /// <summary>
        /// Render the help and statistics text. This function uses the Font object for 
        /// efficient text rendering.
        /// </summary>
        private void RenderText()
        {
            TextHelper txtHelper = new TextHelper(statsFont, textSprite, 15);

            // Output statistics
            txtHelper.Begin();
            txtHelper.SetInsertionPoint(5,5);

            // Draw help
            if (isHelpShowing)
            {
                txtHelper.SetForegroundColor(System.Drawing.Color.Yellow);
                txtHelper.DrawTextLine(sampleFramework.FrameStats);
                txtHelper.DrawTextLine(sampleFramework.DeviceStats);

                txtHelper.SetForegroundColor(System.Drawing.Color.White);

                Matrix m = new Matrix();
                /*
                            txtHelper.DrawTextLine("WorldMatrix");
                            m = camera.WorldMatrix;
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));

                            txtHelper.DrawTextLine("ViewMatrix");
                            m = camera.ViewMatrix;
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
                            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));
                 */
                m = camera.ViewMatrix;
                txtHelper.DrawTextLine(String.Format("J:{0,11:F3}km", m.M43));

                switch (_ʒu)
                {
                    case _.n\:
                    case _.Oj\:
                    case _.j\:
                    case _.\:
                        {
                            // ꂩ̕\ʂ̎\
                            txtHelper.DrawTextLine(String.Format("ܓx:{0,7:F2} / ox:{1,7:F2}", this.pxx, this.pxy));

                            txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 6);
                            txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange);

                            txtHelper.DrawTextLine("J[\L[: ox");
                            txtHelper.DrawTextLine("J[\L[: ܓx");

                        }
                        break;

                    case _.OXe[V:
                    case _.n\Xe[V:
                        {
                            // OGx[^_̎\
                            txtHelper.DrawTextLine(String.Format("ݍx:{0,7:F0}km", this.ݍx - na));

                            txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 6);
                            txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange);

                            txtHelper.DrawTextLine("J[\L[: x㉺");

                        }
                        break;

                    default:
                        {
                            txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 6);
                            txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange);
                        }
                        break;

                }
                

                txtHelper.DrawTextLine("Quit: Esc");
                txtHelper.DrawTextLine("F1:wv");

            }
            else
            {
                txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*2);
                txtHelper.SetForegroundColor(System.Drawing.Color.White);
                txtHelper.DrawTextLine("F1:wv");
            }

            txtHelper.End();
        }















        /// <summary>
        /// ړ_ړ
        /// </summary>
        private void Jړ()
        {
            rotationX = Matrix.Identity;
            rotationX.RotateX((float)(angX * Math.PI / 180));

            rotationY = Matrix.Identity;
            rotationY.RotateY((float)(angY * Math.PI / 180));

            rotation = rotationX * rotationY;

            // ----------------------
            // \px

            //ܓx(0-90)
            pxx = (float)(Math.Asin(Math.Sin(angX * Math.PI / 180)) * 180 / Math.PI);

            //ox(0-180) ():- (E):+
            pxy = -(float)(Math.Asin(Math.Sin(angY * Math.PI / 360 )) *360 / Math.PI);


            vp = Vector3.TransformNormal(defaultDir, rotation);

            if( _ʒu == _.\ )
                vp.X += this.O;
        }



        /// <summary>
        /// As a convenience, the sample framework inspects the incoming windows messages for
        /// keystroke messages and decodes the message parameters to pass relevant keyboard
        /// messages to the application.  The framework does not remove the underlying keystroke 
        /// messages, which are still passed to the application's MsgProc callback.
        /// </summary>
        private void OnKeyEvent(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            switch(e.KeyCode)
            {
                case System.Windows.Forms.Keys.F1:
                    isHelpShowing = !isHelpShowing;
                    break;

                // ->
                case System.Windows.Forms.Keys.Right:
                    angY -= 0.5f;
                    Jړ();
                    break;

                // <-
                case System.Windows.Forms.Keys.Left:
                    angY += 0.5f;
                    Jړ();
                    break;

                // 
                case System.Windows.Forms.Keys.Up:
                    if ((_ʒu == _.OXe[V) || (_ʒu == _.n\Xe[V))
                    {
                        vp.X += OGx[^㉺;    // vp.X = x

                        // Œō x
                        if (vp.X > OXgO)
                        {
                            vp.X = OXgO;
                        }

                        this.ݍx = vp.X;

                        return;
                    }

                    angX += 0.5f;

                    Jړ();
                    break;

                // 
                case System.Windows.Forms.Keys.Down:
                    if ((_ʒu == _.OXe[V) || (_ʒu == _.n\Xe[V))
                    {
                        vp.X -= OGx[^㉺;    // vp.X = x

                        // Œō x
                        if (vp.X < na)
                        {
                            vp.X = na;
                        }

                        this.ݍx = vp.X;

                        return;
                    }

                    angX -= 0.5f;

                    Jړ();
                    break;
            }
        }

        /// <summary>
        /// Before handling window messages, the sample framework passes incoming windows 
        /// messages to the application through this callback function. If the application sets 
        /// noFurtherProcessing to true, the sample framework will not process the message
        /// </summary>
        public IntPtr OnMsgProc(IntPtr hWnd, NativeMethods.WindowMessage msg, IntPtr wParam, IntPtr lParam, ref bool noFurtherProcessing)
        {
            // Give the dialog a chance to handle the message first
            noFurtherProcessing = hud.MessageProc(hWnd, msg, wParam, lParam);
            if (noFurtherProcessing)
                return IntPtr.Zero;

            noFurtherProcessing = sampleUi.MessageProc(hWnd, msg, wParam, lParam);
            if (noFurtherProcessing)
                return IntPtr.Zero;

            // Pass all remaining windows messages to camera so it can respond to user input
            camera.HandleMessages(hWnd, msg, wParam, lParam);

            return IntPtr.Zero;
        }

        /// <summary>
        /// Initializes the application
        /// </summary>
        public void InitializeApplication()
        {
            int y = 10;
            // Initialize the HUD
            Button fullScreen = hud.AddButton(ToggleFullscreen,"Toggle full screen", 35, y, 125,22);
            Button toggleRef = hud.AddButton(ToggleReference,"Toggle reference (F3)", 35, y += 24, 125,22);
            Button changeDevice = hud.AddButton(ChangeDevice,"Change Device (F2)", 35, y += 24, 125,22);
            // Hook the button events for when these items are clicked
            fullScreen.Click += new EventHandler(OnFullscreenClicked);
            toggleRef.Click += new EventHandler(OnRefClicked);
            changeDevice.Click += new EventHandler(OnChangeDeviceClicked);

            // Now add the sample specific UI
            y = 10;
            const int Radiobutton1 = ChangeDevice + 10;
            const int Radiobutton2 = ChangeDevice + 20;
            const int Radiobutton3 = ChangeDevice + 30;
            const int Radiobutton4 = ChangeDevice + 40;
            const int Radiobutton5 = ChangeDevice + 50;
            const int Radiobutton6 = ChangeDevice + 60;
            const int Radiobutton7 = ChangeDevice + 70;

            const int CheckBox1    = ChangeDevice + 80;
            const int CheckBox2    = ChangeDevice + 90;

            // WI{^
            sampleUi.AddRadioButton(Radiobutton1, 1, "nS",         60, y += 24, 125, 22, true);
            sampleUi.AddRadioButton(Radiobutton2, 1, "n\",         60, y += 24, 125, 22, false);
            sampleUi.AddRadioButton(Radiobutton3, 1, "Oj\",         60, y += 24, 125, 22, false);
            sampleUi.AddRadioButton(Radiobutton4, 1, "j\",         60, y += 24, 125, 22, false);
            sampleUi.AddRadioButton(Radiobutton5, 1, "\",           60, y += 24, 125, 22, false);
            sampleUi.AddRadioButton(Radiobutton6, 1, "OXe[V", 60, y += 24, 125, 22, false);
            sampleUi.AddRadioButton(Radiobutton7, 1, "n\Xe[V", 60, y += 24, 125, 22, false);

            
            // WI{^ `FW (OnRadioButtonChanged\bhs)
            sampleUi.GetRadioButton(Radiobutton1).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton2).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton3).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton4).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton5).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton6).Changed += new EventHandler(On_ؑ);
            sampleUi.GetRadioButton(Radiobutton7).Changed += new EventHandler(On_ؑ);


            // `FbN{bNX
            sampleUi.AddCheckBox(CheckBox1, "Gx[^E", 60, y += 24, 125, 22, true);
            sampleUi.GetCheckbox(CheckBox1).Changed += new EventHandler(On\);

            sampleUi.AddCheckBox(CheckBox2, "\bh\", 60, y += 24, 125, 22, false);
            sampleUi.GetCheckbox(CheckBox2).Changed += new EventHandler(On\bh\);


            // If you wanted to respond to any of these you would need to add an event hook here
            this.an = new ();
            this.bj = new ();
            this.cOj = new ();
            this.d   = new ();

            this.ans = new ();
            this.bjs = new ();
            this.cOjs = new ();
            this.ds = new ();

            this.eOXe[V = new ();
            this.f_ = new ();

            this.~a = new ~();
            this.~b = new ~();

            this.a = new ();
            this.b = new ();


            this.an.RotateX_Pitch((float)Math.PI / 2);
            this.bj.RotateX_Pitch((float)Math.PI / 2);
            this.cOj.RotateX_Pitch((float)Math.PI / 2);

            this.d.RotateX_Pitch((float)Math.PI / 2);

            this.ans.RotateX_Pitch((float)Math.PI / 2);
            this.bjs.RotateX_Pitch((float)Math.PI / 2);
            this.cOjs.RotateX_Pitch((float)Math.PI / 2);

            this.ds.RotateX_Pitch((float)Math.PI / 2);

            this.eOXe[V.RotateX_Pitch((float)Math.PI / 2);
            this.f_.RotateX_Pitch((float)Math.PI / 2);

            this.~a.RotateY_Yaw((float)Math.PI / 2);
            this.~b.RotateY_Yaw((float)Math.PI / 2);

            ݍx = na;    // OGx[^ݍx n̒S:0

        }


        // OGx[^\ؑ
        private void On\(object sender, EventArgs e)
        {
            b\ = !b\;
        }


        // Ṽ\bh\ؑ
        private void On\bh\(object sender, EventArgs e)
        {
            b\bh\ = !b\bh\;
        }
        
        
        /// <summary>Called when the combo box has changed</summary>
        // WI{^ɂ鎋_̐؂ւ
        private void On_ؑ(object sender, EventArgs e)
        {
            RadioButton rb = sender as RadioButton;

            if ("nS" == rb.GetTextCopy())
            {
                // n:S
                _ʒu = _.nS;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir = Vector3.Empty;

                this.angX = this.angY = 0f;

                vp = this.defaultDir;

                camera.Reset();
                camera.SetRadius(cameraDefn, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂
            }
            else if ("n\" == rb.GetTextCopy())
            {
                // n:\
                _ʒu = _.n\;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = 0;
                this.defaultDir.Y = 0;
//              this.defaultDir.Z = -(na + 0.1f);
                this.defaultDir.Z = -(na + \ʕ\_ );

                this.angX = this.angY = 0f;

                vp = this.defaultDir;

                camera.Reset();
                camera.SetRadius(cameraDef\, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂
            }
            else if ("Oj\" == rb.GetTextCopy())
            {
                // Oj:\
                _ʒu = _.Oj\;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = 0;
                this.defaultDir.Y = 0;
//              this.defaultDir.Z = -(Oja + 0.1f);
                this.defaultDir.Z = -(Oja + \ʕ\_ );

                this.angX = this.angY = 0f;

                vp = this.defaultDir;

                camera.Reset();
                camera.SetRadius(cameraDef\, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂

            }
            else if ("j\" == rb.GetTextCopy())
            {
                // j:\
                _ʒu = _.j\;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = 0;
                this.defaultDir.Y = 0;
//              this.defaultDir.Z = -(ja + 0.1f);
                this.defaultDir.Z = -(ja + \ʕ\_);

                this.angX = this.angY = 0f;

                vp = this.defaultDir;

                camera.Reset();
                camera.SetRadius(cameraDef\, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂
            }
            else if ("\" == rb.GetTextCopy())
            {
                // :\
                _ʒu = _.\;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = 0;
                this.defaultDir.Y = 0;
//              this.defaultDir.Z = -(a + 0.1f );
                this.defaultDir.Z = -(a + \ʕ\_);

                this.angX = this.angY = 0f;

                vp = this.defaultDir;

                camera.Reset();
                camera.SetRadius(cameraDef\, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂
            }
            else if ("OXe[V" == rb.GetTextCopy())
            {
                // OXe[V
                _ʒu = _.OXe[V;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = Î~O;
                this.defaultDir.Y = 0;
                this.defaultDir.Z = 0;

                vp = this.defaultDir;
                this.ݍx = vp.X;

                this.angX = this.angY = 0f;

                camera.Reset();
                camera.SetRadius(cameraDefw, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂

            }
            else if ("n\Xe[V" == rb.GetTextCopy())
            {
                // n\Xe[V
                _ʒu = _.n\Xe[V;
                this.sampleFramework.Reset3DEnvironment();  // 3DfoCXZbg

                this.defaultDir.X = na;
                this.defaultDir.Y = 0;
                this.defaultDir.Z = 0;

                vp = this.defaultDir;
                this.ݍx = vp.X;

                this.angX = this.angY = 0f;

                camera.Reset();
                camera.SetRadius(cameraDefw, cameraMin, cameraMax);   // J̋ default,min,max

                Jړ();   // _XV̂
            }


        }








        /// <summary>Called when the change device button is clicked</summary>
        private void OnChangeDeviceClicked(object sender, EventArgs e)
        {
            sampleFramework.ShowSettingsDialog(!sampleFramework.IsD3DSettingsDialogShowing);
        }

        /// <summary>Called when the full screen button is clicked</summary>
        private void OnFullscreenClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleFullscreen();
        }

        /// <summary>Called when the ref button is clicked</summary>
        private void OnRefClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleReference();
        }

        /// <summary>
        /// Entry point to the program. Initializes everything and goes into a message processing 
        /// loop. Idle time is used to render the scene.
        /// </summary>
        static int Main() 
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            using(Framework sampleFramework = new Framework())
            {
                kyuu sample = new kyuu(sampleFramework);
                // Set the callback functions. These functions allow the sample framework to notify
                // the application about device changes, user input, and windows messages.  The 
                // callbacks are optional so you need only set callbacks for events you're interested 
                // in. However, if you don't handle the device reset/lost callbacks then the sample 
                // framework won't be able to reset your device since the application must first 
                // release all device resources before resetting.  Likewise, if you don't handle the 
                // device created/destroyed callbacks then the sample framework won't be able to 
                // recreate your device resources.
                sampleFramework.Disposing += new EventHandler(sample.OnDestroyDevice);
                sampleFramework.DeviceLost += new EventHandler(sample.OnLostDevice);
                sampleFramework.DeviceCreated += new DeviceEventHandler(sample.OnCreateDevice);
                sampleFramework.DeviceReset += new DeviceEventHandler(sample.OnResetDevice);

                sampleFramework.SetWndProcCallback(new WndProcCallback(sample.OnMsgProc));

                sampleFramework.SetCallbackInterface(sample);
                try
                {

                    // Show the cursor and clip it when in full screen
                    sampleFramework.SetCursorSettings(true, true);

                    // Initialize
                    sample.InitializeApplication();

                    // Initialize the sample framework and create the desired window and Direct3D 
                    // device for the application. Calling each of these functions is optional, but they
                    // allow you to set several options which control the behavior of the sampleFramework.
                    sampleFramework.Initialize( true, true, true ); // Parse the command line, handle the default hotkeys, and show msgboxes
                    sampleFramework.CreateWindow("kyuu");
                    // Hook the keyboard event
                    sampleFramework.Window.KeyDown += new System.Windows.Forms.KeyEventHandler(sample.OnKeyEvent);
                    sampleFramework.CreateDevice( 0, true, Framework.DefaultSizeWidth, Framework.DefaultSizeHeight, 
                        sample);

                    // Pass control to the sample framework for handling the message pump and 
                    // dispatching render calls. The sample framework will call your FrameMove 
                    // and FrameRender callback when there is idle time between handling window messages.
                    sampleFramework.MainLoop();

                }
#if(DEBUG)
                catch (Exception e)
                {
                    // In debug mode show this error (maybe - depending on settings)
                    sampleFramework.DisplayErrorMessage(e);
#else
            catch
            {
                // In release mode fail silently
#endif
                    // Ignore any exceptions here, they would have been handled by other areas
                    return (sampleFramework.ExitCode == 0) ? 1 : sampleFramework.ExitCode; // Return an error code here
                }

                // Perform any application-level cleanup here. Direct3D device resources are released within the
                // appropriate callback functions and therefore don't require any cleanup code here.
                return sampleFramework.ExitCode;
            }
        }
    }
}
